# vcs.py
#
# Copyright (C) 2014 Tim Marston <tim@edm.am>
#
# This file is part of stdhome (hereafter referred to as "this program").
# See http://ed.am/dev/stdhome for more information.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


class Vcs:


	vcses = [ 'bzr' ]


	@staticmethod
	def instantiate_vcs( vcs, full_dir ):

		# calculate module and class name
		class_name = module_name = ''
		bits = vcs.split( '-' )
		for bit in bits:
			class_name += bit[ 0 ].upper() + bit[ 1 : ]
			if module_name: module_name += '_'
			module_name += bit
		class_name += 'Vcs'
		module_name = 'stdhome.vcs.' + module_name

		# instantiate
		module = __import__( module_name, fromlist = [ class_name ] )
		return getattr( module, class_name )( full_dir )


	class VcsError( Exception ):

		def __init__( self, message, output = None ):
			self.msg = message
			self.output = output
